# Track button state
execute if block ~ ~ ~ #buttons[powered=true] run scoreboard players set @s doorbells.is_powered 1
execute if block ~ ~ ~ #buttons[powered=false] run scoreboard players set @s doorbells.is_powered 0

# Start the door bell
execute if score @s doorbells.is_powered matches 1 if score @s doorbells.was_powered matches 0 run function doorbells:listener/ring/start/_ with entity @s

# Tick down note timer
execute if score @s doorbells.notes_left matches 1.. if score @s doorbells.next_note_timer matches 1.. run scoreboard players remove @s doorbells.next_note_timer 1

# Play next note
execute if score @s doorbells.notes_left matches 1.. if score @s doorbells.next_note_timer matches 0 run function doorbells:listener/ring/_ with entity @s

scoreboard players operation @s doorbells.was_powered = @s doorbells.is_powered

# Kill listener when button is gone
execute unless block ~ ~ ~ #buttons run function doorbells:listener/remove/_